import java.awt.*;
import java.awt.geom.*;

/**
 * Trida pro praci s obdelnikem na virtualnim platne.
 * Je soucasti projektu Tvary, ktery slouzi k demonstraci moznosti 
 * vyuky objektove orientovaneho programovani.
 *
 * @author     Rudolf Pecinovsky
 * @version    1.01, prosinec 2002
 */

public class Obdelnik implements IKresleny
{
//== ATRIBUTY TRIDY ============================================================
 
    private static int    krok   = 50;
    private static int    pocet  = 0;
    private static String oBarva = "cervena";


//== ATRIBUTY INSTANCI =========================================================

    private int xPos;
    private int yPos;
    private int sirka;
    private int vyska;
    private Barva barva;
    private int poradi = ++pocet;
    private String nazev;


//== PRISTUPOVE METODY ATRIBUTU TRIDY ==========================================

    /**
     * Vrati velikost implicitniho kroku, o ktery se obdelnik presune
     * pri volani bezparametrickych metod presunu.
     *
     * @return velikost implicitniho kroku v bodech
     */
     public static int getKrok()
     {
         return krok;
     }//public static int getKrok()


    /**
     * Nastavi velikost implicitniho kroku, o ktery se obdelnik presune
     * pri volani bezparametrickych metod presunu.
     *
     * @param velikost  velikost implicitniho kroku v bodech; velikost>=0
     */
    public static void setKrok(int velikost)
    {
        if( velikost < 0 )
            throw new IllegalArgumentException(
                "Krok nesmi byt zaporny: velikost=" + velikost );
        krok = velikost;
    }//public static void setKrok(int velikost)



//== KONSTRUKTORY ==============================================================

    /**
     * Vytvori novy obdelnik s implicitnimi rozmery, umistenim a barvou.
     * Obdelnik bude umisten v levem hornim rohu platna a bude mit implicitni,
     * (na pocatku cervenou) barvu, vysku 20 bodu a sirku 40 bodu.
     */
    public Obdelnik()
    {
        this( 0, 0, 40, 20 );
    }//public Obdelnik()


    /**
     * Vytvori novy obdelnik se zadanou polohou a rozmery
     * a implicitni (na pocatku cervenou) barvou.
     *
     * @param x   x-ova souradnice, x>=0, x=0 ma levy okraj platna
     * @param y   y-ova souradnice, y>=0, y=0 ma horni okraj platna
     * @param w   sirka obdelniku,  w > 0
     * @param h   vyska obdelniku,  h > 0
     */
    public Obdelnik( int x, int y, int w, int h )
    {
        this( x, y, w, h, oBarva );
    }//public Obdelnik( String nazev, int x, int y, int w, int h )


    /**
     * Vytvori novy obdelnik se zadanymi rozmery, polohou a barvou.
     *
     * @param x   x-ova souradnice, x>=0, x=0 ma levy okraj platna
     * @param y   y-ova souradnice, y>=0, y=0 ma horni okraj platna
     * @param w   sirka obdelniku,  w > 0
     * @param h   vyska obdelniku,  h > 0
     * @param c barva obdelniku - povolene hodnoty jsou:
     *                    "cerna",  "modra",     "cervena", "fialova",
     *                    "zelena", "azurova", "zluta",   "bila".
     */
    public Obdelnik( int x, int y, int w, int h, String c )
    {
        //Test platnosti parametru
        if( (x<0) || (y<0) || (w<=0) || (h<=0) )
            throw new IllegalArgumentException(
                "Parametry nemaji povolene hodnoty: x="
                + x + ", y=" + y + ", w=" + w + ", h=" + h );
        barva = Barva.getBarva( c );


        //Parametry akceptovany --> muzeme tvorit
        sirka = w;
        vyska = h;
        xPos = x;
        yPos = y;
        
        nazev =  "Obdelnik_" + poradi;
    }//public Obdelnik( String nazev, int x, int y, int w, int h, String c )



//== PRISTUPOVE METODY ATRIBUTU INSTANCI =======================================

    /**
     * Vrati x-ovou souradnici obdelniku, 
     * tj. souradnici jeho leveho horniho rohu .
     *
     * @return x-ova souradnice leveho horniho rohu obdelniku
     */
     public int getX()
     {
         return xPos;
     }//public int getX()


    /**
     * Vrati y-ovou souradnici obdelniku, 
     * tj. souradnici jeho leveho horniho rohu .
     *
     * @return y-ova souradnice leveho horniho rohu obdelniku
     */
     public int getY()
     {
         return yPos;
     }//public int getY()


    /**
     * Nastavi novou polohu obdelniku.
     * tj. polohu jeho leveho horniho rohu .
     *
     * @param x   x-ova pozice leveho horniho rohu obdelniku
     * @param y   y-ova pozice leveho horniho rohu obdelniku
     */
    public void setPozice(int x, int y)
    {
        xPos = x;
        yPos = y;
        AnimPlatno.getPlatno().prekresli();
    }//public void setPozice(int x, int y)


    /**
     * Vrati sirku obdelniku.
     *
     * @return  sirka obdelniku v bodech
     */
     public int getSirka()
     {
         return sirka;
     }//public int getSirka()


    /**
     * Vrati vysku obdelniku.
     *
     * @return  vyska obdelniku v bodech
     */
     public int getVyska()
     {
         return vyska;
     }//public int getVyska()


    /**
     * Nastavi novou velikost stran obdelniku -
     * na zadanou velikost se nastavi vyska i sirka.
     *
     * @param velikost  nove nastavovana velikost; velikost>0
     */
    public void setVelikost(int velikost)
    {
        setRozmer( velikost, velikost );
    }//public void setVelikost(int velikost)


    /**
     * Nastavi nove rozmery obdelniku.
     *
     * @param w    nove nastavovana sirka; w>0
     * @param h    nove nastavovana vyska; h>0
     */
    public void setRozmer(int w, int h)
    {
        if( (w <= 0) || (h <= 0) )
            throw new IllegalArgumentException(
                "Rozmery musi byt kladne: w=" + w + ", h=" + h );
        sirka = w;
        vyska = h;
        AnimPlatno.getPlatno().prekresli();
    }//public void setRozmer(int rozmer)


    /**
     * Vráti barvu obdelniku.
     *
     * @return  instance tridy Barva definujici nastavenou barvu
     */
    public Barva getBarva()
    {
        return barva;
    }//public Barva getBarva()


    /**
     * Nastavi novou barvu obdelniku.
     *
     * @param nova nastavovana barva - povolene hodnoty jsou:
     *             "cerna",  "modra",     "cervena", "fialova",
     *             "zelena", "azurova", "zluta",   "bila".
     */
    public void setBarva(String nova)
    {
        //Pri prevodu se zaroven otestuje akceptovatelnost nastavovane barvy
        barva = Barva.getBarva( nova );
        AnimPlatno.getPlatno().prekresli();
    }//public void setBarva(String nova)


    /**
     * Nastavi novou barvu obdelniku.
     *
     * @param nova nastavovana barva - povolene hodnoty jsou:
     *             "cerna",  "modra",     "cervena", "fialova",
     *             "zelena", "azurova", "zluta",   "bila".
     */
    public void setBarva(Barva nova)
    {
        //Pri prevodu se zaroven otestuje akceptovatelnost nastavovane barvy
        barva = nova;
        AnimPlatno.getPlatno().prekresli();
    }//public void setBarva(Barva nova)


    /**
     * Vráti nazev obdelniku.
     *
     * @return  aktualni nazev daneho obdelniku
     */
    public String getNazev()
    {
        return nazev;
    }//public String getNazev()



//== OSTATNI METODY INSTANCI ===================================================

    /**
     * Nakresli obdelnik na platno.
     */
    public void kresli( Graphics2D g )
    {
        g.setColor( barva );
        g.fill( new Rectangle2D.Double(xPos, yPos, sirka, vyska) );
    }//public void kresli( Graphics2D g )


    /**
     * Presune obdelnik o zadany pocet bodu vpravo,
     * pri zaporne hodnote parametru vlevo.
     *
     * @param vzdalenost  pocet bodu, o kterou se obdelnik presune
     */
    public void posunVpravo(int vzdalenost)
    {
        xPos += vzdalenost;
        AnimPlatno.getPlatno().prekresli();
    }//public void posunVpravo(int vzdalenost)


    /**
     * Presune obdelnik krok bodu vpravo.
     */
    public void posunVpravo()
    {
        posunVpravo(krok);
    }//public void posunVpravo()


    /**
     * Presune obdelnik o krok bodu vlevo.
     */
    public void posunVlevo()
    {
        posunVpravo(-krok);
    }//public void posunVlevo()


    /**
     * Pomalu presune obdelnik o zadany pocet bodu vpravo,
     * pri zaporne hodnote parametru vlevo.
     *
     * @param vzdalenost pocet bodu, o ktere se obdelnik presune
     */
    public void pomaluVpravo(int vzdalenost)
    {
        int delta;
        AnimPlatno platno = AnimPlatno.getPlatno();

        if(vzdalenost < 0)
        {
            delta = -1;
            vzdalenost = -vzdalenost;
        }
        else
        {
            delta = 1;
        }

        for(int i = 0; i < vzdalenost; i++)
        {
            posunVpravo( delta );
            platno.cekej(10);
        }
    }//public void pomaluVpravo(int vzdalenost)


    /**
     * Presune obdelnik o zadany pocet bodu dolu,
     * pri zaporne hodnote parametru nahoru.
     *
     * @param vzdalenost  pocet bodu, o ktere se obdelnik presune
     */
    public void posunDolu(int vzdalenost)
    {
        yPos += vzdalenost;
        AnimPlatno.getPlatno().prekresli();
    }//public void posunDolu(int vzdalenost)


    /**
     * Presune obdelnik o krok bodu nahoru.
     */
    public void posunVzhuru()
    {
        posunDolu(-krok);
    }//public void posunVzhuru()


    /**
     * Presune obdelnik o krok bodu dolu.
     */
    public void posunDolu()
    {
        posunDolu(krok);
    }//public void posunDolu()


    /**
     * Pomalu presune obdelnik o zadany pocet bodu dolu,
     * pri zaporne hodnote parametru nahoru.
     *
     * @param vzdalenost pocet bodu, o ktere se obdelnik presune
     */
    public void pomaluDolu(int vzdalenost)
    {
        int delta;
        AnimPlatno platno = AnimPlatno.getPlatno();

        if(vzdalenost < 0)
        {
            delta = -1;
            vzdalenost = -vzdalenost;
        }
        else
        {
            delta = 1;
        }

        for(int i = 0; i < vzdalenost; i++)
        {
            posunDolu( delta );
            platno.cekej(10);
        }
    }//public void pomaluDolu(int vzdalenost)

}//public class Obdelnik implements IKresleny